#!/util/bin/perl

# Lists the zones (primary and secondary) for the index frame.

use Bind;

sub zonesort {
    my(@a) = split(/\./,$a);
    my(@b) = split(/\./,$b);

    while (@a) {
	$aval = pop @a;
	$bval = pop @b;
	if ($aval =~ /^\d+$/ && $bval =~ /^\d+$/) {
	    if ($foo = $aval <=> $bval) {
		return $foo;
	    }
	} else {
	    if ($foo = $aval cmp $bval) {
		return $foo;
	    }
	}
    }
    return 0;
}

$dns = new Bind("/local/stock/Bind/domain/named.boot");

print "Content-type: text/html\n\n";

if (!defined($dns)) {
    print "Database is currently being locked.  Please try again later.\n";
    exit 0;
}

@zones = sort zonesort $dns->zonelist("PRIMARY");

# Gross, but actually pretty fast...
foreach (@zones) {
    if (!/\.IN-ADDR\.ARPA\.$/) {
	print "<a href=\"showzone.cgi?zone=$_\" target=\"show\">$_</a><br>\n";
    }
}
foreach (@zones) {
    if (/\.IN-ADDR\.ARPA\.$/) {
	print "<a href=\"showzone.cgi?zone=$_\" target=\"show\">$_</a><br>\n";
    }
}
